﻿#! /usr/bin/python

APP_TITLE = "Recaller"
APP_VERSION = "2.1"

import gobject
import os
from os import environ
import cairo
#import osso
import string
import time 
import gconf
import urllib
import sys

import ctypes
import gettext
#import evolution

import dbus

gobject.threads_init ()
import pygst
pygst.require("0.10")
import gst

from dbus.mainloop.glib import DBusGMainLoop
dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
dbus.mainloop.glib.threads_init()



class RecallerHomePlugin():

  def __init__(self):


    #List of default values
    #self.source = "Bluetooth"
    self.source = "Phone"
    self.folder = "/home/user/MyDocs/Dictafon"
    self.fileformat = "aac"
    self.autorec = True
      
    self.isStopped = True 
    self.transparency = 0.0  
    
    root = self.bus.get_object('org.bluez', '/')
    manager = dbus.Interface(root, 'org.bluez.Manager')
    defaultAdapter = manager.DefaultAdapter()    
    obj = self.bus.get_object('org.bluez', defaultAdapter)
    self.BTadapter = dbus.Interface(obj, 'org.bluez.Adapter')
    
    
    
             

    self.bus = dbus.bus.BusConnection("unix:path=/var/run/dbus/system_bus_socket")

    #---Incoming/outgoing callbacks---------------------------

    #[SIGNAL] com.nokia.csd.Call.UserConnection  /com/nokia/csd/call  :1.17
    #( true )           
    self.bus.add_signal_receiver(self.offHook,
                            dbus_interface=None,
                            signal_name="UserConnection",
                            bus_name="com.nokia.csd",
                            path="/com/nokia/csd/call",
                            )
                                
    #[SIGNAL] com.nokia.csd.Call.Instance.Terminated  /com/nokia/csd/call/1  :1.17
    #()
    self.bus.add_signal_receiver(self.onHook,
                            dbus_interface=None,
                            signal_name="Terminated",
                            bus_name="com.nokia.csd",
                            path="/com/nokia/csd/call/1",
                            )
                            
                        
    #---Incoming callbacks------------------------------------
    
    #[SIGNAL] com.nokia.csd.Call.Coming  /com/nokia/csd/call  :1.17
    #( op'/com/nokia/csd/call/1', "0313520331" )
    self.bus.add_signal_receiver(self.callInfoFrom,
                            dbus_interface=None,
                            signal_name="Coming",
                            bus_name="com.nokia.csd",
                            path="/com/nokia/csd/call",
                            )

    #---Outgoing callbacks------------------------------------
    #[SIGNAL] com.nokia.csd.Call.Created  /com/nokia/csd/call  :1.17
    #( op'/com/nokia/csd/call/1', "+41313520331" )
    self.bus.add_signal_receiver(self.callInfoTo,
                            dbus_interface=None,
                            signal_name="Created",
                            bus_name="com.nokia.csd",
                            path="/com/nokia/csd/call",
                            )
  
  
          
  def start_PhoneRecording(self):
      self.folderDate = time.strftime("%d.%m.%Y")
      self.startTime = time.strftime("%H'%M'%S")
      self.startTimeToDisplay = time.strftime("%H'%M'%S")
      if os.access(os.path.join(self.folder, self.folderDate), os.F_OK)==0:
        os.mkdir(os.path.join(self.folder, self.folderDate))
      if self.caller == None:
        self.fileName = os.path.join(self.folder, self.folderDate,"rec_%s.%s" % (self.startTime,self.fileformat.lower()))
      else:
        self.fileName = os.path.join(self.folder, self.folderDate,"%s_%s.%s" % (self.caller,self.startTime,self.fileformat.lower()))  
      self.fileName = os.path.join(self.folder, self.folderDate,"CurrentlyRecording.%s" % self.fileformat.lower())
      print "Self.source="+self.source 
      print "self.fileName="+self.fileName 
      print "Launcher config is:"
      print self.get_launcher()
      #self.gsterr = ""
      self.recorder = gst.parse_launch ( self.get_launcher())
      #print "parse_error:"+str(self.gsterr)
      if self.recorder == None:
        print "Launch failure!"
        return
      # else:
        # print "launch state"
        # print self.recorder.get_state(1)
      bus = self.recorder.get_bus()
      # need to connect to sync message handler so we get the sink to be
      # embedded at the right time and not have a temporary new window
      bus.enable_sync_message_emission()
      bus.add_signal_watch()
      bus.connect("sync-message::element", self.on_sync_message)
      bus.connect("message", self.on_message)
      self.recorder.set_state(gst.STATE_PLAYING)
      #success, state, pending = self.recorder.get_state(1)
      #if state != gst.STATE_PLAYING:
      #  self.log("ERROR: Failed to start recording in gstreamer!")
      #  return
 
      self.isStopped = False
    
      # print "phonerecording!"
      
  def stop(self):
      self.recorder.send_event(gst.event_new_eos())

      
  def cleanup(self):
      self.isStopped=True
      if self.caller == None:
        finalName = os.path.join(self.folder, self.folderDate,"rec_%s-%s.%s" % (self.startTime,time.strftime("%H'%M'%S"),self.fileformat.lower()))
      else:
        finalName = os.path.join(self.folder, self.folderDate,"%s_%s-%s.%s" % (self.caller,self.startTime,time.strftime("%H'%M'%S"),self.fileformat.lower()))       
      os.rename(self.fileName, finalName)
   
      
  

  def on_sync_message(self, bus, message):
      if message.structure is None:
          return
      if message.structure.get_name() == 'prepare-xwindow-id':
          # all this is needed to sync with the X server before giving the
          # x id to the sink

    
          message.src.set_property("force-aspect-ratio", True)
   

  def on_message(self, bus, message):
      if message.type == gst.MESSAGE_ERROR:
        self.recorder.set_state(gst.STATE_NULL)
        err, debug = message.parse_error()
        print "GST ERROR"
        print str(err)
        print str(debug)
        self.cleanup()
      if message.type == gst.MESSAGE_EOS:
        self.recorder.set_state(gst.STATE_NULL)
        self.cleanup()
      

      
  def get_launcher(self):
      enc = self.get_encoder()
      if self.source == "Phone":
        self.launcher = "adder name=theAdder ! %s ! filesink location=\"%s\" . pulsesrc device=sink.hw0.monitor ! queue name=q1 ! theAdder. pulsesrc device=source.hw0 ! audioamplify amplification=30.0 ! queue name=q2 ! theAdder."  % (enc,self.fileName)
      elif self.source == "Bluetooth":
        self.launcher = "adder name=theAdder ! %s ! filesink location=\"%s\" . pulsesrc device=sink.hw1.monitor ! audioamplify amplification=10.0 ! queue name=q1 ! theAdder. pulsesrc device=source.hw1 ! audioamplify amplification=5.0 ! queue name=q2 ! theAdder."  % (enc,self.fileName)
      elif self.source == "Dictaphone":
        self.launcher = "pulsesrc device=source.hw0 ! audioconvert ! audioamplify amplification=30.0 ! queue ! %s ! filesink location=\"%s\"" % (enc,self.fileName)
      elif self.source == "System":
        self.launcher = "pulsesrc device=sink.hw0.monitor ! audioconvert ! queue ! %s ! filesink location=\"%s\"" % (enc,self.fileName)
      return self.launcher

  def get_encoder(self):
      if self.fileformat.lower() == "aac":
        self.encoder = "nokiaaacenc bitrate=128000 output-format=1"
      elif self.fileformat.lower() == "flac":
        self.encoder = "flacenc"
      elif self.fileformat.lower() == "wav":
        self.encoder = "wavenc"
      elif self.fileformat.lower() == "spx":
        self.encoder = "speexenc"
      return self.encoder
      
 

  def callInfoFrom(self,sender, message):
    if sender == "/com/nokia/csd/call/1":
      if message == None:
        message = "Unknown"
      message = message.replace ( '*', '+' )
      # print message
      
      # senderuid = self.cb.get_uid_from_number(message)
      # if senderuid != None:
        # sender = self.cb.get_displayname_from_uid(senderuid)
      # if sender != None:
        # sndr = sender
      # print sndr
      self.caller = str(message)


  def callInfoTo(self,sender, message):
    if sender == "/com/nokia/csd/call/1":
      self.caller = str(message)

    
  def offHook(self,connection):
    if connection == True:
      if self.autorec:
        self.currentsource = self.source  #Store original audio source
        #Switch to handsfree if connected
        self.hasHandsfree = self.hasHandsfreeConnected()
        if self.hasHandsfree == True:
          self.source = "Bluetooth" 
          self.log("Self.source set to Bluetooth")          
        else:
          self.source = "Phone"
        #elif self.source == "Dictaphone" or self.source == "System":
          # sourceSwitchingNeeded = True
          # self.log("hasHandsfree="+str(hasHandsfree))
          # if hasHandsfree:
            # self.source == "Bluetooth"
            # self.log("Self.source set to Bluetooth")
          # else:
          #self.source == "Phone"
    
        #Special case: a recording is already running
        if self.isStopped == False:
          if self.currentsource == self.source: #Just abort and continue recording
            return
          else:                         #Stop the current recording and restart new one
            success, state, pending = self.recorder.get_state(1)
            if not pending:
              if state == gst.STATE_PLAYING:
                self.stop()
            
        self.start_PhoneRecording()
        self.isStopped = False
            
  def onHook(self):
    #print sender, "said:", message
    #if sender == "/com/nokia/csd/call/1":
    if not self.isStopped:  #Recording still running, let's stop
      try:
        if(self.source == "Bluetooth"): #Emergency stop or we will crash when the BT source/sink disappear moments later...
          if not self.recorder is None:
            self.recorder.set_state(gst.STATE_NULL)
          self.source = self.currentsource
          if not self.timer is None:     
            gobject.source_remove(self.timer)
          self.cleanup()
          self.log("Did emergency full stop due to BT headset being used :-)")
          return
      except:
        print(sys.exc_info()[0])
      #For all others, clean up a bit more properly
      success, state, pending = self.recorder.get_state(1)
      if not pending:
        if state == gst.STATE_PLAYING:
          self.source = self.currentsource  #Restore original audio source  
          self.stop()

      
  def hasHandsfreeConnected(self):
    #If BT is disabled, we can already abort
    props = self.BTadapter.GetProperties()
    powered = props['Powered']
    if powered:
      print "BT is currently ON"
    else:
      print "BT is currently OFF"
      return False

    #Enumerate the devices
    remoteDevices = props['Devices']
    for dev in remoteDevices:
      devObj = self.bus.get_object('org.bluez', dev)
      device = dbus.Interface(devObj, 'org.bluez.Device')
      devProps = device.GetProperties()
      devName = devProps['Name']
      isConnected = devProps['Connected']
      #Check if a connected device offers a handsfree service
      if isConnected:
        #print devName
        UUIDs = devProps['UUIDs']
        for uuid in UUIDs:
          id = uuid[4:8]
          if id == "111e":
            #print " is a connected handsfree device !"
            return True
    return False  

         
recallerstart = RecallerHomePlugin()     
                  
if __name__ == "__main__":
	recallerstart 
 
gobject.MainLoop().run()   		
    




